﻿using System;
using System.Collections.Generic;

namespace BookService
{
    public class Author : IComparable<Author>
    {
        public String firstName;
        public String lastName;

        private static Author[] authors;

        static Author()
        {
            List<Author> allAuthors = new List<Author>();
            allAuthors.Add(new Author("Don", "DeLillo"));
            allAuthors.Add(new Author("Thomas", "Pynchon"));
            allAuthors.Add(new Author("Neal", "Stephenson"));

            authors = allAuthors.ToArray();
        }

        public Author(String firstName, String lastName)
        {
            this.firstName = firstName;
            this.lastName = lastName;
        }

        public static Author[] getAuthors()
        {
            return authors;
        }

        public int CompareTo(Author other)
        {
            int result = this.lastName.CompareTo(other.lastName);
            if (result == 0)
            {
                return this.firstName.CompareTo(other.firstName);
            }
            else return result;
        }

        public override string ToString()
        {
            return "Author: " + lastName + ", " + firstName;
        }

        public override bool Equals(object obj)
        {
            if (obj == null || !(obj is Author)) return false;

            Author other = (Author)obj;
            return ((this.firstName == other.firstName) && (this.lastName == other.lastName));
        }

        public override int GetHashCode()
        {
            return (this.lastName + this.firstName).GetHashCode();
        }
    }
}
